package com.proyek.akhir.kodel.ui.koperasi.produk.addProduk

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.Toast
import com.proyek.akhir.kodel.R
import com.proyek.akhir.kodel.data.response.ProdukResponse
import com.proyek.akhir.kodel.data.response.Produks
import com.proyek.akhir.kodel.ui.koperasi.produk.ProdukKoperasiActivity
import com.proyek.akhir.kodel.utils.ApiClient
import kotlinx.android.synthetic.main.activity_tambah_produk.*
import retrofit2.Call
import retrofit2.Response

class TambahProdukActivity : AppCompatActivity() {

    lateinit var nameProduk: String
    lateinit var hargaProduk: String
    lateinit var satuanProduk: String

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_tambah_produk)

        progressTambahKupon.visibility = View.INVISIBLE

        btnTambahProduk.setOnClickListener {
            progressTambahKupon.visibility = View.VISIBLE
            nameProduk = productName.text.toString()
            hargaProduk = hargaProdukValue.text.toString()
            satuanProduk = kategoryProduk.text.toString()
            val produk = Produks(
                "",
                hargaProduk.toInt(),
                5,
                8,
                nameProduk,
                satuanProduk
            )

            postProduk(produk)
        }


    }

    private fun postProduk(produks: Produks) {
        progressTambahKupon.visibility = View.VISIBLE

        val produks = ProdukResponse(produks)

        ApiClient().postServicePeople().postProduk(produks)
            .enqueue(object : retrofit2.Callback<ProdukResponse> {
                override fun onFailure(call: Call<ProdukResponse>, t: Throwable) {
                    Toast.makeText(this@TambahProdukActivity, "Jaringan Lemah", Toast.LENGTH_SHORT)
                        .show()
                }

                override fun onResponse(
                    call: Call<ProdukResponse>,
                    response: Response<ProdukResponse>
                ) {
                    if (response.isSuccessful) {
                        progressTambahKupon.visibility = View.GONE
                        startActivity(
                            Intent(
                                this@TambahProdukActivity,
                                ProdukKoperasiActivity::class.java
                            )
                        )
                        finish()
                    } else {
                        progressTambahKupon.visibility = View.INVISIBLE
                        Toast.makeText(
                            this@TambahProdukActivity,
                            "Jaringan Lemah!",
                            Toast.LENGTH_SHORT
                        ).show()
                    }
                }

            })
    }

}
